; Written by: RuiLoureiro
;
include \masm32\include\masm32rt.inc
.686p

;  CONSOLE ASSEMLBLE & LINK 

CreateLkdList       proto   :DWORD,:DWORD,:DWORD,:DWORD
DestroyLkdList      proto   :DWORD

InsertLkdList       proto   :DWORD,:DWORD,:DWORD
DeleteLkdList       proto   :DWORD,:DWORD,:DWORD


NODE struct
   iNext   dd ?
   iPrev   dd ?
   LkdData db 80 dup (?) 
NODE ends

IDXFSTLIST      equ 12
IDXLSTLIST      equ 8
IDXALCLIST      equ 4

LENNODE         equ sizeof NODE
;
.data

    Frut1       db "orange", 0
    Frut2       db "melon", 0
    Frut3       db "quince", 0
    Frut4       db "apricot", 0
    Frut5       db "strawberry", 0
    Frut6       db "peach", 0
    Frut7       db "grape", 0
    Frut8       db "apple", 0
    Frut9       db "melon", 0
    Frut10      db "cherry", 0
    Frut11      db "almond", 0
    Frut12      db "lemon", 0
    Frut13      db "pear", 0
    Frut14      db "mulberry", 0
    Frut15      db "banana", 0
    Frut16      db "loquat", 0
    Frut17      db "walnut", 0
    Frut18      db "mango", 0
    Frut19      db "fig", 0
    Frut20      db "passion-fruit", 0

.data?
   pBuffer      dd ?
   pList        dd ?
;
.code

start:
   
        invoke   CreateLkdList, 20, sizeof NODE, addr pBuffer, addr pList
        jc       _exit

        ;call     SeeLkdList
        
        invoke   InsertLkdList, pList, sizeof NODE, addr Frut1
        invoke   InsertLkdList, pList, sizeof NODE, addr Frut2
        invoke   InsertLkdList, pList, sizeof NODE, addr Frut3
        invoke   InsertLkdList, pList, sizeof NODE, addr Frut4
        invoke   InsertLkdList, pList, sizeof NODE, addr Frut5
        invoke   InsertLkdList, pList, sizeof NODE, addr Frut6
        invoke   InsertLkdList, pList, sizeof NODE, addr Frut7

        call     ShowLkdListDn
        call     ShowLkdListUp

        print   "DELETE melon, strawberry, apricot ", 13, 10

        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut2
        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut5
        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut4

        call     ShowLkdListDn
        call     ShowLkdListUp

        call     ShowAlloc

        print   "INSERT melon, strawberry, apricot ", 13, 10

        invoke   InsertLkdList, pList, sizeof NODE, addr Frut2
        invoke   InsertLkdList, pList, sizeof NODE, addr Frut4
        invoke   InsertLkdList, pList, sizeof NODE, addr Frut5


        call     ShowLkdListDn
        call     ShowLkdListUp

        call     ShowAlloc
;----------------------------------
        print   "DELETE ALL ", 13, 10

        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut1
        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut2
        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut3        
        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut4
        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut5
        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut6
        invoke   DeleteLkdList, pList, sizeof NODE, addr Frut7        

        call     ShowLkdListDn
        call     ShowLkdListUp

        call     ShowAlloc

   ;---------------------
_exit:
        inkey
        invoke   DestroyLkdList, pBuffer

        exit
;
DeleteLkdList       proc    pLst:DWORD, lReg:DWORD, pStr:DWORD
                    LOCAL   IdxCur, IdxNxt, IdxPre:DWORD
                    
                    push    ebx
                    push    esi
                    push    edi
                    ;
                    mov     esi, pStr
                    mov     edi, pLst

                    call    LenStringN

                    mov     eax, dword ptr [edi - IDXFSTLIST]       ; Idx First
                    cmp     eax, 0
                    jne     short _start
                    ;
                    ; is empty
                    ; --------
                    stc
                    jmp     _end

        _next:      mov     eax, IdxNxt
                    cmp     eax, 0
                    je      _not
                    
        _start:     mov     IdxCur, eax
        
                    mov     edx, lReg
                    sub     eax, 1
                    mul     edx
                    add     eax, edi
                    mov     ebx, eax
                    ;
                    mov     eax, dword ptr [ebx].NODE.iNext         ; Idx Next
                    mov     IdxNxt, eax
                    mov     edx, dword ptr [ebx].NODE.iPrev         ; Idx Prev
                    mov     IdxPre, edx

                    call    CmpStrings
                    ja      short _next
                    jb      short _not
                    ;
                    ; is this
                    ; -------
                    mov     edx, dword ptr [edi - IDXALCLIST]            ; Alloc                    
                    mov     eax, IdxCur                    
                    mov     dword ptr [edi - IDXALCLIST], eax            ; Alloc
                    mov     dword ptr [ebx].NODE.iNext, edx              ; Idx Next
                    ;
                    mov     eax, IdxPre
                    cmp     eax, 0
                    je      _first
                    ;
                    mov     edx, lReg
                    sub     eax, 1
                    mul     edx
                    add     eax, edi
                    mov     edx, eax
                    
                    mov     eax, IdxNxt
                    mov     dword ptr [edx].NODE.iNext, eax              ; Idx Next
                    cmp     eax, 0
                    je      _last

                    mov     edx, lReg
                    sub     eax, 1
                    mul     edx
                    add     eax, edi

                    mov     edx, IdxPre
                    mov     dword ptr [eax].NODE.iPrev, edx           ; Idx Prev
                    clc
                    jmp     _end
;--------------------
        _last:      mov     eax, IdxPre
                    mov     dword ptr [edi - IDXLSTLIST], eax       ; Idx Last
                    clc
                    jmp     _end
;--------------------
        _first:     mov     eax, IdxNxt                             ; Idx next
                    mov     dword ptr [edi - IDXFSTLIST], eax       ; Idx First
                    cmp     eax, 0
                    je      short @F

                    mov     edx, lReg
                    sub     eax, 1
                    mul     edx
                    add     eax, edi

                    mov     dword ptr [eax].NODE.iPrev, 0           ; Idx Prev
                    clc
                    jmp     _end

            @@:     mov     dword ptr [edi - IDXLSTLIST], eax       ; Idx Last
                    clc                    
                    jmp     _end
    ;--------------
    _not:           stc
    _end:           pop     edi
                    pop     esi
                    pop     ebx
                    ret
DeleteLkdList       endp        
;
InsertLkdList       proc    pLst:DWORD, lReg:DWORD, pStr:DWORD
                    push    ebx
                    push    esi
                    push    edi
                    ;
                    mov     esi, pStr
                    mov     edi, pLst
                    mov     eax, dword ptr [edi - IDXALCLIST]            ; Alloc

                    cmp     eax, 0
                    jne     short @F
                    ;
                    ; Is full
                    ; -------
                    stc
                    jmp     _end
                    

    @@:             mov     ebx, eax
    
                    sub     eax, 1
                    mov     ecx, lReg
                    mul     ecx
                    add     eax, edi
                    
                    mov     edx, dword ptr [eax].NODE.iNext
                    mov     dword ptr [edi - IDXALCLIST], edx         ; Alloc

                    mov     dword ptr [eax].NODE.iNext, 0
                    mov     dword ptr [eax].NODE.iPrev, 0

                    call    SetLkdList
                    
                    cmp     dword ptr [edi - IDXFSTLIST], 0           ; Idx First
                    jne     short _next
                    ;
                    ; Is first
                    ; --------
                    mov     dword ptr [edi - IDXFSTLIST], ebx         ; Idx First
                    mov     dword ptr [edi - IDXLSTLIST], ebx         ; Idx Last                    
                    jmp     _end
                    
    _next:          call    CmpLkdList
    
                    clc
    _end:           pop     edi
                    pop     esi
                    pop     ebx
                    ret
InsertLkdList       endp 
;
;       ESI     - pStr    
;       EDI     - pList
;       ECX     - lReg
;
CmpLkdList          proc
                    LOCAL   LenReg, IdxNew, PtrNew, IdxCur, IdxNxt, IdxPre:DWORD
                    push    esi
                    push    edi

                    mov     PtrNew, eax                             ; Ptr new
                    mov     IdxNew, ebx                             ; Idx new
                    mov     LenReg, ecx                             ; Len Reg

                    call    LenStringN

                    mov     eax, dword ptr [edi - IDXFSTLIST]       ; Idx First
                    jmp     short _start
                    
        _next:      mov     eax, IdxNxt
                    cmp     eax, 0
                    je      _last
                    
        _start:     mov     IdxCur, eax
        
                    mov     edx, LenReg
                    sub     eax, 1
                    mul     edx
                    add     eax, edi
                    mov     ebx, eax
                    ;
                    mov     eax, dword ptr [ebx].NODE.iNext         ; Idx Next
                    mov     IdxNxt, eax
                    mov     edx, dword ptr [ebx].NODE.iPrev         ; Idx Prev
                    mov     IdxPre, edx

                    call    CmpStrings
                    jae     short _next
;--------------------
                    mov     eax, IdxPre
                    cmp     eax, 0
                    je      _first

                    mov     edx, IdxNew                             ; Idx new
                    mov     dword ptr [ebx].NODE.iPrev, edx         ; Idx Prev

                    mov     edx, IdxCur
                    ;mov     eax, IdxPre
                    
                    mov     ebx, PtrNew                             ; Ptr new
                    mov     dword ptr [ebx].NODE.iNext, edx         ; Idx Next
                    mov     dword ptr [ebx].NODE.iPrev, eax         ; Idx Prev

                    mov     edx, LenReg
                    sub     eax, 1
                    mul     edx
                    add     eax, edi

                    mov     edx, IdxNew                             ; Idx new
                    mov     dword ptr [eax].NODE.iNext, edx         ; Idx Next
                    jmp     _end
;--------------------
        _last:      mov     eax, IdxNew                             ; Idx new
                    mov     dword ptr [edi - IDXLSTLIST], eax       ; Idx Last
                    mov     dword ptr [ebx].NODE.iNext, eax         ; Idx Next

                    mov     eax, IdxCur
                    mov     ebx, PtrNew                             ; Ptr new
                    mov     dword ptr [ebx].NODE.iPrev, eax         ; Idx Prev
                    jmp     _end
;--------------------
        _first:     mov     eax, IdxNew                             ; Idx new
                    mov     dword ptr [edi - IDXFSTLIST], eax       ; Idx First
                    mov     dword ptr [ebx].NODE.iPrev, eax         ; Idx Prev

                    mov     eax, IdxCur
                    mov     ebx, PtrNew                             ; Ptr new
                    mov     dword ptr [ebx].NODE.iNext, eax         ; Idx Next
                    
        _end:       pop     edi
                    pop     esi
                    ret
CmpLkdList          endp
;
LenStringN          proc

                    xor     ecx, ecx
                    jz      short _start
                    
        @@:         add     ecx, 1
        _start:     cmp     byte ptr [esi + ecx], 0
                    jne     short @B

                    ret
LenStringN          endp
;
LenStringX          proc
                    xor     edx, edx
                    jz      short _start
                    
        @@:         add     edx, 1
        _start:     cmp     byte ptr [edi + edx], 0
                    jne     short @B

                    ret
LenStringX          endp
;
;       ESI     - pStr    
;       EDI     - pList
;       ECX     - lReg
;       EBX     - pReg Cur
;
CmpStrings          proc
                    push    ecx
                    push    esi
                    push    edi

                    lea     edi, dword ptr [ebx].NODE.LkdData
                    call    LenStringX
                    ;
                    cmp     ecx, edx
                    jb      short _below
                    ja      short _above     

    ;***---***
    _equal:         movzx   eax, byte ptr [esi]
                    cmp     al, byte ptr [edi]
                    jne     _fim
                    ;
                    add     esi, 1
                    add     edi, 1
                    ;
                    sub     ecx, 1
                    jnz     short _equal
                    jz      _fim

    ;***---***
    _above:         movzx   eax, byte ptr [esi]
                    cmp     al, byte ptr [edi]
                    jne     _fim
                    ;
                    add     esi, 1
                    add     edi, 1
                    ;
                    sub     edx, 1
                    jnz     short _above
                    jz      short _cmp
    ;***---***
    _below:         movzx   eax, byte ptr [esi]
                    cmp     al, byte ptr [edi]
                    jne     _fim
                    ;
                    add     esi, 1
                    add     edi, 1
                    ;
                    sub     ecx, 1
                    jnz     short _below
        
    _cmp:           cmp     ecx, edx

    _fim:           pop     edi
                    pop     esi
                    pop     ecx
                    ret
CmpStrings          endp
;
SetLkdList          proc
                    push    eax
                    push    esi
                    
        @@:         movzx   edx, byte ptr [esi]                    
                    mov     byte ptr [eax].NODE.LkdData, dl
                    add     esi, 1
                    add     eax, 1
                    cmp     dl, 0
                    jne     short @B

                    pop     esi                    
                    pop     eax
                    ret
SetLkdList          endp 
;
PutLkdList          proc
                    push    eax
                    push    esi
                    push    edi
                    
                    lea     edi, dword ptr [eax].NODE.LkdData
                    
        @@:         movzx   eax, byte ptr [esi]                    
                    mov     byte ptr [edi], al
                    add     esi, 1
                    add     edi, 1
                    cmp     al, 0
                    jne     short @B
                    
                    pop     edi
                    pop     esi
                    pop     eax                    
                    ret
PutLkdList          endp      
;
CreateLkdList       proc    nReg:DWORD, lReg:DWORD, pBuf:DWORD, pLst:DWORD

                    mov     eax, nReg
                    mov     edx, lReg
                    mul     edx
                    add     eax, 16
                    ;
                    invoke  GlobalAlloc, GMEM_FIXED, eax
                    cmp     eax, NULL
                    jne     @F
                    stc
                    ret
                    
        @@:         push    ebx
                    push    edi
                    
                    mov     edx, pBuf
                    mov     dword ptr [edx], eax
                    add     eax, 12
                    mov     edi, eax
                    ;
                    mov     edx, pLst
                    mov     dword ptr [edx], eax
                    ;
                    mov     dword ptr [edi - IDXALCLIST], 1         ; Alloc
                    mov     dword ptr [edi - IDXFSTLIST], 0         ; Idx First
                    mov     dword ptr [edi - IDXLSTLIST], 0         ; Idx Last
                    ;
                    mov     ecx, nReg
                    sub     ecx, 1
                    ;
                    mov     eax, lReg
                    mul     ecx
                    add     eax, edi
                    mov     dword ptr [eax].NODE.iNext, 0
                    ;
        @@:         mov     ebx, ecx
                    add     ebx, 1
                    ;
                    sub     ecx, 1
                    ;
                    mov     eax, lReg
                    mul     ecx
                    add     eax, edi
                    mov     dword ptr [eax].NODE.iNext, ebx
                    ;
                    cmp     ecx, 0
                    jne     short @B

                    clc        
                    pop     edi
                    pop     ebx
                    ret
CreateLkdList       endp
;
DestroyLkdList      proc    pBuf:DWORD
                    invoke  GlobalFree, pBuf
                    ret
DestroyLkdList      endp
;
SeeLkdList          proc
                    pushad
                    ;
                    mov     edi, pList
                    ;print   str$(edi), 13, 10
                    ;inkey
                    ;
                    mov     ebx, 1
                    
        @@:         push    ebx
                    sub     ebx, 1                    
                    mov     eax, LENNODE
                    mul     ebx
                    add     eax, edi
                    mov     eax, dword ptr [eax].NODE.iNext

                    print   str$(eax), 13, 10
                    inkey
                    ;
                    pop     ebx
                    
                    add     ebx, 1
                    cmp     ebx, 10
                    jbe     @B
                    
                    popad
                    ret
SeeLkdList          endp
;
ShowLkdListUp       proc
                    pushad

                    print   "From BOTTOM to TOP ", 13, 10

                    mov     edi, pList
                    call    ShowHeader
                    
                    mov     ebx, dword ptr [edi - IDXLSTLIST]            ; Idx Last

        _next:      cmp     ebx, 0
                    je      _fim
                    
                    mov     ecx, LENNODE
                    mov     eax, ebx
                    sub     eax, 1
                    mul     ecx
                    add     eax, edi
                    mov     esi, eax
                    ;
                    print   "Cur= "
                    print   str$(ebx)
                    ;
                    print   "   Next= "
                    mov     eax, dword ptr [esi].NODE.iNext
                    print   str$(eax)
                    ;
                    print   "   Prev= " 
                    mov     eax, dword ptr [esi].NODE.iPrev
                    print   str$(eax)
                    ;
                    print   "   String= "
                    lea     ebx, dword ptr [esi].NODE.LkdData
                    print   ebx, 13, 10
                    ;
                    mov     ebx, dword ptr [esi].NODE.iPrev                    
                    jmp     _next
                    

        _fim:       ;inkey
                    print   "  ", 13, 10

                    popad
                    ret
ShowLkdListUp       endp
;
ShowLkdListDn       proc
                    pushad

                    print   " ", 13, 10
                    print   "From TOP to BOTTOM ", 13, 10

                    mov     edi, pList
                    call    ShowHeader

                    mov     ebx, dword ptr [edi - IDXFSTLIST]            ; Idx First
                    
        _next:      cmp     ebx, 0
                    je      _fim
                    
                    mov     ecx, LENNODE
                    mov     eax, ebx
                    sub     eax, 1
                    mul     ecx
                    add     eax, edi
                    mov     esi, eax
                    ;
                    print   "Cur= "
                    print   str$(ebx)
                    ;
                    print   "   Next= "
                    mov     eax, dword ptr [esi].NODE.iNext
                    print   str$(eax)
                    ;
                    print   "   Prev= " 
                    mov     eax, dword ptr [esi].NODE.iPrev
                    print   str$(eax)
                    ;
                    print   "   String= "
                    lea     ebx, dword ptr [esi].NODE.LkdData
                    print   ebx, 13, 10
                    ;
                    mov     ebx, dword ptr [esi].NODE.iNext                    
                    jmp     _next
                    
        _fim:       ;inkey
                    print   " ", 13, 10

                    popad
                    ret
ShowLkdListDn       endp
;
ShowHeader          proc

                    print   "Alloc= "
                    mov     eax, dword ptr [edi - IDXALCLIST]            ; Alloc
                    print   str$(eax), 13, 10

                    print   "First= "
                    mov     eax, dword ptr [edi - IDXFSTLIST]            ; Idx First
                    print   str$(eax), 13, 10
                    ;
                    print   "Last= "
                    mov     eax, dword ptr [edi - IDXLSTLIST]            ; Idx Last
                    print   str$(eax), 13, 10
                    ;
                    ret
ShowHeader          endp
;
ShowAlloc           proc
                    pushad

                    print   " ", 13, 10
                    print   "Alloc structure ", 13, 10

                    mov     edi, pList
                    
                    print   "Alloc= "
                    mov     ebx, dword ptr [edi - IDXALCLIST]            ; Alloc
                    print   str$(ebx), 13, 10
                    ;
        _next:      cmp     ebx, 0
                    je      _end

                    mov     ecx, LENNODE
                    mov     eax, ebx
                    sub     eax, 1
                    mul     ecx
                    add     eax, edi
                    mov     esi, eax
                    ;
                    print   "Cur= "
                    print   str$(ebx)

                    print   "   Next Alloc= "
                    mov     ebx, dword ptr [esi].NODE.iNext                    
                    print   str$(ebx), 13, 10
                    jmp     _next


        _end:       inkey
        
                    popad
                    ret
ShowAlloc           endp
;
end start
